﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;


namespace DataGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;

            #region DataSource
            DataCollection dataSource = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 0; i < 100; i++)
            {
                dataSource.Add(new Data(r, "Category" + r.ToString(), r + i +.01 , r.ToString() + "Data"));
                r = rand.Next(100);
            }
            this.gridGroupingControl1.DataSource = dataSource;

            #endregion

            foreach (GridColumnDescriptor col in this.gridGroupingControl1.TableDescriptor.Columns)
            {
                if (col.MappingName == "CategoryID")
                {
                    col.Appearance.AnyRecordFieldCell.CellValueType = typeof(int);
                }
                col.AllowFilter = true;
            }
            //Form()
            GridExcelFilter excelfilter = new GridExcelFilter();
            excelfilter.WireGrid(this.gridGroupingControl1);
            excelfilter.EnableNumberFilter = true;
            excelfilter.RecordFiltersItemChanged += excelfilter_RecordFiltersItemChanged;
            excelfilter.RecordFiltersItemChanging += excelfilter_RecordFiltersItemChanging;
            gridGroupingControl1.DisplayElementChanged += gridGroupingControl1_DisplayElementChanged;
         
        }

        void gridGroupingControl1_DisplayElementChanged(object sender, DisplayElementChangedEventArgs e)
        {
            FilteredRecordsInTableCollection filteredRecords = this.gridGroupingControl1.Table.FilteredRecords;
            MessageBox.Show("FilteredReocords count from DisplayElementChanged:" + filteredRecords.Count.ToString()); 
        }

        void excelfilter_RecordFiltersItemChanging(object sender, Syncfusion.Collections.ListPropertyChangedEventArgs e)
        {
            FilteredRecordsInTableCollection filteredRecords = this.gridGroupingControl1.Table.FilteredRecords;
            MessageBox.Show("FilteredReocords count from recordfilteritemschanging:" + filteredRecords.Count.ToString()); 
        }

        void excelfilter_RecordFiltersItemChanged(object sender, Syncfusion.Collections.ListPropertyChangedEventArgs e)
        {
            FilteredRecordsInTableCollection filteredRecords = this.gridGroupingControl1.Table.FilteredRecords;
            MessageBox.Show("FilteredReocords count from recordfilteritemschanged:" + filteredRecords.Count.ToString()); 
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FilteredRecordsInTableCollection filteredRecords = this.gridGroupingControl1.Table.FilteredRecords;
            MessageBox.Show("FilteredReocords count from button1:" + filteredRecords.Count.ToString()); 

        }

        private void gridGroupingControl1_TableSourceListChanged(object sender, TableEventArgs e)
        {
            FilteredRecordsInTableCollection filteredRecords = this.gridGroupingControl1.Table.FilteredRecords;
            MessageBox.Show("FilteredReocords count from sourcelistchanged:" + filteredRecords.Count.ToString()); 

        }

        private void gridGroupingControl1_FilterBarSelectedItemChanged(object sender, FilterBarSelectedItemChangedEventArgs e)
        {
            FilteredRecordsInTableCollection filteredRecords = this.gridGroupingControl1.Table.FilteredRecords;
            MessageBox.Show("FilteredReocords count from filter bar changed:" + filteredRecords.Count.ToString()); 

        }
    }
}
